##
##  re2c.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         re2c
Summary:      Regular Expression to C Compiler
URL:          http://re2c.org/
Vendor:       P. Bumbulis, B. Young, D. Nuffer, M. Boerger
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        PLUS
Group:        CompilerCompiler
License:      MIT/PD
Version:      0.16
Release:      20160307

#   list of sources
Source0:      http://downloads.sourceforge.net/re2c/re2c-%{version}.tar.gz
Patch0:       re2c.patch

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, gcc, make, bison
PreReq:       OpenPKG, openpkg >= 20160101

%description
    re2c is a tool for generating C-based recognizers from regular
    expressions. re2c-based scanners are efficient: for programming
    languages, given similar specifications, an re2c-based scanner is
    typically almost twice as fast as a flex-based scanner with little
    or no increase in size (possibly a decrease on cisc architectures).
    Indeed, re2c-based scanners are quite competitive with hand-crafted
    ones.

%track
    prog re2c = {
        version   = %{version}
        url       = http://sourceforge.net/projects/re2c/files/
        regex     = re2c-(\d+\.\d+)\.tar\.gz
    }

%prep
    %setup -q
    %patch -p0

%build
    CC="%{l_cc}" \
    CFLAGS="%{l_cflags -O}" \
    CPPFLAGS="%{l_cppflags}" \
    CXXFLAGS="%{l_cxxflags -O} -I. -Wno-unused -Wno-parentheses -Wno-deprecated -fpermissive" \
    ./configure \
        --prefix=%{l_prefix}
    %{l_make} %{l_mflags -O}

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/man/man1
    %{l_shtool} install -c -s -m 755 \
        re2c $RPM_BUILD_ROOT%{l_prefix}/bin/
    %{l_shtool} install -c -m 644 \
        doc/re2c.1 $RPM_BUILD_ROOT%{l_prefix}/man/man1/
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

